package controls;
import pixi.core.display.Container;
import pixi.core.math.Point;
import pixi.core.sprites.Sprite;
import util.Asset;

/**
 * ...
 * @author Henri Sarasvirta
 */
class Piece extends Container
{
	public static var SHAPES:Array<Array<String>> = [
		[
			"1",
			"1",
			"1",
			"1"
			
		],
		[
			"10",
			"10",
			"11"
		],
		[
			"01",
			"01",
			"11"
		],
		[
			"10",
			"11",
			"01"
		],
		[
			"011",
			"110"
		],
		[
			"110",
			"011"
		],
		[
			"11",
			"11"
		]
		
	];
	
	private static var colors:Array<Int> = [
		0xFF0000,
		0x00FF00,
		0x0000FF,
		0xFF00FF,
		0xFFFF00
	];
		
	public var coordinates:Array<Point> = [];
		
	public var gy:Int = 0;
	public var gx:Int = 0;
	public var color:Int = 0x0;	
	
	public var squares:Array<Sprite> = [];
	
	public var gridWidth:Int = 0;
	public var gridHeight:Int = 0;
	
	public function new() 
	{
		super();
		this.color = colors[Math.floor(Math.random() * colors.length)];
		
		this.setPieceType( Math.floor(Math.random() * SHAPES.length));
	}
	
	public function setPieceType(val:Int):Void
	{
		var pieces:Array<String> = SHAPES[val];
		for (i in 0...pieces.length)
		{
			var row:String = pieces[i];
			for (j in 0...row.length)
			{
				var val:String = row.charAt(j);
				if (val == "1")
				{
					var s:Sprite = Asset.getImage("square.png", true);
					this.addChild(s);
					s.width = Grid.SQUARE;
					s.height = Grid.SQUARE;
					s.x = j * s.width;
					s.y = i * s.height;
					
					s.tint = this.color;
					this.squares.push(s);
					this.coordinates.push( new Point(j,i));
					
					gridHeight =cast Math.max(gridHeight,i);
					gridWidth =cast Math.max(gridWidth, j);
				}
			}
		}
	}
	
	public function testHit(x:Int, y:Int):Bool
	{
		for (c in coordinates) 
		{
			if (c.x + this.gx == x && c.y + this.gy == y)
				return true;
		}
		return false;
	}
	
	public function rotate():Void
	{
		//Update coordinates
		for (i in 0...coordinates.length)
		{
			var c:Point = coordinates[i];
			var tmp:Int = cast c.x;
			c.x = gridHeight - c.y;
			c.y = tmp;
			var s:Sprite = this.squares[i];
			s.x = c.x * Grid.SQUARE;
			s.y = c.y * Grid.SQUARE;
		}
		
		var tmp:Int = gridHeight;
		gridHeight = gridWidth;
		gridWidth = tmp;
	}
	
}