package controls;
import pixi.core.display.Container;
import pixi.core.math.Point;
import pixi.core.sprites.Sprite;
import util.Asset;
import util.IntStepIter;

/**
 * ...
 * @author Henri Sarasvirta
 */
class Worm extends Container
{
	//Position history
	public var coordinates:Array<Point>=[];
	private var revert:Array < Point>;
	
	public var dirX:Int = 0;
	public var dirY:Int = 0;
	
	public var pieces:Array<Sprite> = [];
	
	public function new() 
	{
		super();
		this.initializeControls();
	}
	
	private function initializeControls():Void
	{
		var color:Int = Math.floor(0xFFFFFF * Math.random());
		for (i in 0...5)
		{
			var p:Sprite = Asset.getImage("worm.png", true);
			pieces.push(p);
			p.tint = color;
			p.width = Grid.SQUARE;
			p.height = Grid.SQUARE;
			this.addChild(p);
		this.coordinates.push(new Point(i, 0));
		}		
		this.dirX = 1;
		this.dirY = 0;
	}
	
	public function moveWorm():Void
	{
		this.revert = [];
		for (c in coordinates)
		{
			this.revert.push(new Point(c.x, c.y));
		}
		
		//Move forward.
		for ( i in new IntStepIter(this.coordinates.length-1, 0, -1))
		{
			coordinates[i].x = coordinates[i - 1].x;
			coordinates[i].y = coordinates[i - 1].y;
		}
		coordinates[0].x += dirX;
		coordinates[0].y += dirY;
		
		
		//Update the pieces
		this.updatePieces();
	}
	
	private function updatePieces():Void
	{
		for (i in 0...coordinates.length)
		{
			this.pieces[i].x = coordinates[i].x * Grid.SQUARE;
			this.pieces[i].y = coordinates[i].y * Grid.SQUARE;
		}
	}
	
	public function revertPieces():Void
	{
		this.coordinates = this.revert;
		updatePieces();
	}
	
	public function increaseSize():Void
	{
		var p:Sprite = Asset.getImage("worm.png", true);
		pieces.push(p);
		p.tint = Math.floor(0xffffff*Math.random());
		p.width = Grid.SQUARE;
		p.height = Grid.SQUARE;
		this.addChild(p);
		this.coordinates.push(new Point(this.coordinates[this.coordinates.length-1].x,this.coordinates[this.coordinates.length-1].y));

	}
	
}