package;
import controls.Card;
import haxe.Json;
import haxe.Resource;
import js.Lib;

/**
 * ...
 * @author ...
 */
class CardPack
{
	private var mutatorsPool:Array<Card>;
	private var transportsPool:Array<Card>;
	private var limitPool:Array<Card>;
	private var customsHandPool:Array<Card>;
	private var customsOfficersPool:Array<Card>;
	private var smugglerHandPool:Array<Card>;

	public function new() 
	{
		initCards();
	}
	
	public function shuffleDeck(deck:Array<Card>) {
		var start = deck.slice(0);
		var shuffled = new Array<Card>();
		
		while (start.length != 0) {
			var index:Int = cast Math.floor((1000 * Math.random())+5)% start.length;
			var card = start[index];
			
			if (!card.discarded) {
				
				shuffled.push(card);
			}
			start.remove(card);
		}
		return shuffled;
	}

	private function initCards() {
		transportsPool = initPool("autot");
		mutatorsPool = initPool("mutators");
		customsOfficersPool = initPool("hahmot");
		//limitPool = initPool("tullirajat");
		customsHandPool = initPool("tullikamat");
		smugglerHandPool = initPool("kamat");
	}
	
	private function initPool(name:String):Array<Card> {
		var pool = new Array<Card>();
		var data:Dynamic = Json.parse(Resource.getString(name));
		
		for (i in 0...data.items.item.length) {
			var item = data.items.item[i];
			if (item.amount_in_deck == null) {
				var card = new Card(item, name);	
				pool.push(card);
			}
			else {
				for (j in 0...data.items.item[i].amount_in_deck) 
				{
					var card = new Card(data.items.item[i], name);	
					pool.push(card);
				}
			}
		}
		return pool;
	}
	
	public function getMutatorDeck():Array<Card> {
		return shuffleDeck(mutatorsPool);
	}
	
	public function getTransportDeck():Array<Card> {
		return shuffleDeck(transportsPool);
	}
	
	public function getCustomsOfficerDeck():Array<Card> {
		return shuffleDeck(customsOfficersPool);
	}
	
	public function getLimitDeck():Array<Card> {
		return shuffleDeck(limitPool);
	}
	
	public function getCustomsHandDeck():Array<Card> {
		return shuffleDeck(customsHandPool);
	}
	
	public function getSmugglerHandDeck():Array<Card> {
		return shuffleDeck(smugglerHandPool);
	}
}