package controls;
import createjs.tweenjs.Ease;
import createjs.tweenjs.Tween;
import js.Lib;
import pixi.core.display.Container;
import pixi.core.math.Point;

/**
 * ...
 * @author Henri Sarasvirta
 */
class CardDeck extends Container
{
	public var discardOff:Point;
	public var isEnemy:Bool = false;
	
	private var _discarded:Array<Card>;
	public var cards:Array<Card>;
	
	public var mpx:Int = 1;
	public var mpy:Int = 1;
	
	public function new() 
	{
		super();
	}
	
	public function prepare(cards:Array<Card>):Void
	{
		//Setup the initial cards
		this.cards = cards;
		this._discarded = [];
		
		for (i in 0...cards.length)
		{
			var c:Card = cards[i];
			var offset:Int =cast Math.min(6, i);
			c.x = Math.floor(offset * -3)*mpx;
			c.y = Math.floor(offset * -3)*mpy;
			c.scale.y = isEnemy ? -c.scale.x :c.scale.x;
			this.addChild(c);
		}
	}
	
	public function takeCard():Card
	{
		return this.cards.pop();
	}
	
	public function discardCard(card:Card,delay:Int):Void
	{
		var op:Point = card.toGlobal(new Point(0, 0));
		op = this.toLocal(op);
		card.x = op.x;
		card.y = op.y;
		
		var offset:Int =cast Math.min(6, _discarded.length);
		
		Tween.get(card).wait(delay, true).to( { x: Math.floor(offset * -3 + discardOff.x) * mpx
		, y:Math.floor(offset * -3+discardOff.y) * mpy, rotation:0 }, 250, Ease.quadInOut);
		Tween.get(card.pivot).wait(delay, true).to( { x:0, y: 0 }, 250, Ease.quadInOut);
		Tween.get(card.scale).wait(delay, true).to( { x:2.0, y:isEnemy ? -2 :2 }, 250, Ease.quadInOut);
		
		
		this._discarded.push(card);
		this.addChild(card);
	}
	
	public function addCard(card:Card):Void {
		this.cards.push(card);
	}
	
	public function getDiscards():Array<Card> {
		return this._discarded;
	}
	
}