package controls;
import js.Browser;
import js.html.Gamepad;
import js.html.KeyboardEvent;
import pixi.core.display.Container;

/**
 * ...
 * @author Henri Sarasvirta
 */
class Controllers extends Container
{
	public static var WORM_DOWN:String = "wormDown";
	public static var WORM_UP:String = "wormUp";
	public static var WORM_LEFT:String = "wormLeft";
	public static var WORM_RIGHT:String = "wormRight";
	
	public static var LEFT_ON:String = "leftOn";
	public static var RIGHT_ON:String = "rightOn";
	public static var LEFT_OFF:String = "leftOff";
	public static var RIGHT_OFF:String = "rightOff";
	public static var DROP_ON:String = "dropon";
	public static var DROP_OFF:String = "dropoff";
	public static var ROTATE:String = "rotate";
	
	//private var gamepads:Array<GamePad> = [];
	
	public function new() 
	{
		super();
		Browser.window.addEventListener("keydown", onKeyDown);
		Browser.window.addEventListener("keyup", onKeyUp);
	}
	
	private function onKeyUp(e:KeyboardEvent):Void
	{
		trace(e.keyCode);
		if (e.keyCode == 37)
		{
			this.emit(LEFT_OFF);
		}
		else if (e.keyCode == 39)
		{
			this.emit(RIGHT_OFF);
		}
		if (e.keyCode == 40)
		{
			this.emit(DROP_OFF);
		}
	}
	
	private function onKeyDown(e:KeyboardEvent):Void
	{
		if (e.keyCode == 37)
		{
			this.emit(LEFT_ON);
		}
		else if (e.keyCode == 38)
		{
			this.emit(ROTATE);
		}
		else if (e.keyCode == 39)
		{
			this.emit(RIGHT_ON);
		}
		else if (e.keyCode == 40)
		{
			this.emit(DROP_ON);
		}
		else if (e.keyCode == 65)
		{
			this.emit(WORM_LEFT);
		}
		else if (e.keyCode == 68)
		{
			this.emit(WORM_RIGHT);
		}
		else if (e.keyCode == 87)
		{
			this.emit(WORM_UP);
		}
		else if (e.keyCode == 83)
		{
			this.emit(WORM_DOWN);
		}
	}
	
	
	/*var haveEvents = 'ongamepadconnected' in window;
var controllers = {};

function connecthandler(e) {
  addgamepad(e.gamepad);
}

function addgamepad(gamepad) {
  controllers[gamepad.index] = gamepad;

  var d = document.createElement("div");
  d.setAttribute("id", "controller" + gamepad.index);

  var t = document.createElement("h1");
  t.appendChild(document.createTextNode("gamepad: " + gamepad.id));
  d.appendChild(t);

  var b = document.createElement("div");
  b.className = "buttons";
  for (var i = 0; i < gamepad.buttons.length; i++) {
    var e = document.createElement("span");
    e.className = "button";
    //e.id = "b" + i;
    e.innerHTML = i;
    b.appendChild(e);
  }

  d.appendChild(b);

  var a = document.createElement("div");
  a.className = "axes";

  for (var i = 0; i < gamepad.axes.length; i++) {
    var p = document.createElement("progress");
    p.className = "axis";
    //p.id = "a" + i;
    p.setAttribute("max", "2");
    p.setAttribute("value", "1");
    p.innerHTML = i;
    a.appendChild(p);
  }

  d.appendChild(a);

  // See https://github.com/luser/gamepadtest/blob/master/index.html
  var start = document.getElementById("start");
  if (start) {
    start.style.display = "none";
  }

  document.body.appendChild(d);
  requestAnimationFrame(updateStatus);
}

function disconnecthandler(e) {
  removegamepad(e.gamepad);
}

function removegamepad(gamepad) {
  var d = document.getElementById("controller" + gamepad.index);
  document.body.removeChild(d);
  delete controllers[gamepad.index];
}

function updateStatus() {
  if (!haveEvents) {
    scangamepads();
  }

  var i = 0;
  var j;

  for (j in controllers) {
    var controller = controllers[j];
    var d = document.getElementById("controller" + j);
    var buttons = d.getElementsByClassName("button");

    for (i = 0; i < controller.buttons.length; i++) {
      var b = buttons[i];
      var val = controller.buttons[i];
      var pressed = val == 1.0;
      if (typeof(val) == "object") {
        pressed = val.pressed;
        val = val.value;
      }

      var pct = Math.round(val * 100) + "%";
      b.style.backgroundSize = pct + " " + pct;

      if (pressed) {
        b.className = "button pressed";
      } else {
        b.className = "button";
      }
    }

    var axes = d.getElementsByClassName("axis");
    for (i = 0; i < controller.axes.length; i++) {
      var a = axes[i];
      a.innerHTML = i + ": " + controller.axes[i].toFixed(4);
      a.setAttribute("value", controller.axes[i] + 1);
    }
  }

  requestAnimationFrame(updateStatus);
}

function scangamepads() {
  var gamepads = navigator.getGamepads ? navigator.getGamepads() : (navigator.webkitGetGamepads ? navigator.webkitGetGamepads() : []);
  for (var i = 0; i < gamepads.length; i++) {
    if (gamepads[i]) {
      if (gamepads[i].index in controllers) {
        controllers[gamepads[i].index] = gamepads[i];
      } else {
        addgamepad(gamepads[i]);
      }
    }
  }
}


window.addEventListener("gamepadconnected", connecthandler);
window.addEventListener("gamepaddisconnected", disconnecthandler);

if (!haveEvents) {
  setInterval(scangamepads, 500);
}*/
	
	
	
	
	
	
}


