package controls;
import createjs.tweenjs.Ease;
import createjs.tweenjs.Tween;
import pixi.core.display.Container;
import pixi.core.math.Point;
import pixi.core.math.shapes.Rectangle;

/**
 * ...
 * @author ...
 */
class Hand extends Container
{
	public var isEnemy:Bool;
	public var cards:Array<Card>;
	
	public function new() 
	{
		super();
		this.interactiveChildren = true;
	}
	public function prepare():Void
	{
		this.cards = [];
	}
	public function getCardInPosition():Card
	{
		for (c in this.cards)
		{
			if(c.isMouseover)
				return c;
		}
		return null;
	}
	
	public function putCard(card:Card,?delay:Int):Void {
		//TODO: card position
		var op:Point = card.toGlobal(new Point(0, 0));
		op = this.toLocal(op);
		card.x = op.x;
		card.y = op.y;
		this.addChild(card);
		if(!isEnemy)
			card.hitClip.interactive = true;
		
		this.addChild(card.hitClip);
		card.hitClip.x =this.cards.length / 10 * 400;
		card.hitClip.y = 0;
		this.cards.push(card);
		
		if (delay == null) delay = 1;
		
		if(this.isEnemy)
			Tween.get(card).wait(delay, true).to( { x: card.hitClip.x, y:0 }, 250, Ease.quintInOut);
		else
			Tween.get(card).wait(delay, true).to( { x:card.hitClip.x, y:0 }, 250, Ease.quintInOut).call(card.showCard);
		
		
	}
	public function resize():Void
	{
		for (i in 0...this.cards.length)
		{
			var c:Card = this.cards[i];
			c.x = i / 10 * 400;
			c.hitClip.x = c.x;
			c.hitClip.y = c.y;
		}
		updateOrder();
	}
	
	public function updateOrder():Void
	{
		var top:Array<Card>  = [];
		for (i in 0...this.cards.length)
		{
			if (this.cards[i].isMouseover)
			{
				top.push(this.cards[i]);

			}
			else
			{
				this.addChild(this.cards[i]);
				this.addChild(this.cards[i].hitClip);
			}
			this.addChild(this.cards[i].hitClip);
		}
		for (c in top)
		{
			this.addChild(c);
		}
	}
	
	public function removeCard(card:Card):Void
	{
		trace("remove card");
		this.removeChild(card.hitClip);
		card.interactive = false;
		card.isMouseover = false;
		card.hitClip.interactive = false;
		this.cards.remove(card);
	}
	
	public function getCard(index:Int):Card {
			trace("get card");
			if (cards.length == 0) {
				return null;
			}
			var card = cards[Math.floor(index) % cards.length];
			
			this.removeCard(card);
			return card;
		}
}