package controls;

import createjs.tweenjs.Ease;
import createjs.tweenjs.Tween;
import util.Asset;
import pixi.core.display.Container;
import pixi.core.math.Point;
import pixi.core.sprites.Sprite;
import pixi.core.text.Text.TextStyle;
import pixi.core.text.Text;


/**
 * ...
 * @author ...
 */
class Line extends Container
{
	public var Mutator:Card;
	public var hasPlayerCard:Bool = false;
	public var textStyle:TextStyle;
	public var customsText:Text;
	public var smugglerText:Text;
	
	private var cardContainer:Container;
	
	public function new() 
	{
		super();
		initializeControls();
	}
	
	private function initializeControls():Void
	{
		textStyle = {  };
		textStyle.fill = "#ffffff";
		textStyle.font = "30px Arial";
		
		
		customsText = new Text("", textStyle);
		smugglerText = new Text("", textStyle);
		
		untyped customsText.updateText();
		untyped smugglerText.updateText();
		
		smugglerText.x = 40;
		customsText.x = 40;
		
		if (StartView.GAME_TYPE == StartView.GAME_TYPE_CUSTOMS) {
			customsText.y = 240;
			smugglerText.y = 30;
		}
		else
		{
			smugglerText.y = 240;
			customsText.y = 30;
		}
		
		cardContainer = new Container();
		
		var lineAsset = Asset.getImage("linebg.png", false);
		this.addChild(lineAsset);
		this.addChild(cardContainer);
		this.addChild(customsText);
		this.addChild(smugglerText);
	}
	
	private var activeTransport:Card;
	private var activeCustomsOfficer:Card;
	private var activeMutator:Card;
	
	public var playerCard:Card;
	
	public function clearLine():Void {
		this.removeChildren();
	}
	
	public function setTransport(transport:Card,delay:Int):Void {
		activeTransport = transport;
		var isSmuggler:Bool = StartView.GAME_TYPE == StartView.GAME_TYPE_SMUGGLER;
		if (StartView.GAME_TYPE == StartView.GAME_TYPE_SMUGGLER)
		{
			hasPlayerCard = true;
			this.playerCard = transport;
		}
		var op:Point = transport.toGlobal(new Point(0, 0));
		op = this.toLocal(op);
		transport.x = op.x;
		transport.y = op.y;
		Tween.get(transport.pivot).wait(delay, true).to( { x:-20, y:0 }, 250, Ease.quadInOut);
		Tween.get(transport).wait(delay, true).to( { x:0, y:isSmuggler ? 220 : -20 }, 250, Ease.quadInOut);
		Tween.get(transport.scale).wait(delay, true).to( { x:1.0, y:1.0 }, 250, Ease.quadInOut);
		
		/*
		activeTransport.scale.x = 1;
		activeTransport.scale.y = 1;
		
		activeTransport.x = 0;
		activeTransport.y = StartView.GAME_TYPE == StartView.GAME_TYPE_SMUGGLER ? 220 : -20;
*/
		this.cardContainer.addChild(activeTransport);
	}
	
	public function setCustomsOfficer(customsOfficer:Card, delay:Int):Void {
		activeCustomsOfficer = customsOfficer;
		var isCustoms = StartView.GAME_TYPE == StartView.GAME_TYPE_CUSTOMS;
		if (StartView.GAME_TYPE == StartView.GAME_TYPE_CUSTOMS)
		{
			hasPlayerCard = true;
			this.playerCard = customsOfficer;
		}
		var op:Point = customsOfficer.toGlobal(new Point(0, 0));
		op = this.toLocal(op);
		Tween.get(customsOfficer.pivot).wait(delay, true).to( { x: -22, y:0 }, 250, Ease.quadInOut);
		trace("IS CUSTOMS " + isCustoms);
		Tween.get(customsOfficer).wait(delay, true).to( { x:0, y:(isCustoms ? 220 : -20) }, 250, Ease.quadInOut);
		Tween.get(customsOfficer.scale).wait(delay, true).to( { x:1.0, y:1.0 }, 250, Ease.quadInOut);
		
			
		//activeCustomsOfficer.scale.x = 1;
		//activeCustomsOfficer.scale.y = 1;
		
		//activeCustomsOfficer.x = 25;
		//customsOfficer.y = -20;
		//TODO: paikka
		this.cardContainer.addChild(activeCustomsOfficer);	
	}
	
	public function setMutator(mutator:Card,delay:Int) {
		activeMutator = mutator;
		
		var op:Point = mutator.toGlobal(new Point(0, 0));
		op = this.toLocal(op);
		mutator.x = op.x+166;
		mutator.y = op.y-146;
		mutator.rotation = Math.PI/2;
		Tween.get(mutator.pivot).wait(delay, true).to( { x:0, y:0 }, 250, Ease.quadInOut);
		Tween.get(mutator).wait(delay, true).to( { x:120, y:100 }, 250, Ease.quadInOut);
		Tween.get(mutator.scale).wait(delay, true).to( { x:1.5, y:1.5 }, 250, Ease.quadInOut).call(mutator.showCard);
		
		
/*		mutator.x = 120;
		mutator.y = 100;
		mutator.scale.x = 1.5;
		mutator.scale.y = 1.5;
		mutator.rotation = Math.PI/2;*/
		//TODO: paikka/skaala
		this.cardContainer.addChild(mutator);
	}
	
	public function getTransport():Card{
		return activeTransport;
	}
	
	public function getOfficer():Card{
		return activeCustomsOfficer;
	}
		
	public function getMutator():Card {
		return activeMutator;
	}
}