package controls;

import pixi.core.display.Container;
import pixi.core.math.Point;
import pixi.core.sprites.Sprite;
import pixi.core.text.Text.TextStyle;
import pixi.core.text.Text;
import util.Asset;

/**
 * ...
 * @author Henri Sarasvirta
 */
class SideBaseView extends Container
{
	public var bg:Sprite;
	
	public var handDeck:CardDeck;
	public var lineDeck:CardDeck;
	public var eventDeck:CardDeck;
	public var limitDeck:CardDeck;
	public var hand:Hand;
	public var lineHand:Hand;
	public var points:Int = 0;
	
	public var type:String;
	public var scoreTextStyle:TextStyle;
	public var scoreText:Text;
	
	public function addPoints(point:Int) {
		trace("add points:" + point);
		points += point;
		
		scoreText.text = cast points;
	}
	
	public function new(type:String) 
	{
		super();
		this.type = type;
		if(type == "smuggler")
			this.bg = Asset.getImage("smuggler_bg.png", true);
		else
			this.bg = Asset.getImage("customs_bg.png",true);
		
		this.scoreTextStyle = {};
		this.scoreText = new Text("0",this.scoreTextStyle);
		this.scoreText.x = 1000;
		this.scoreText.y = 200;
		this.addChild(this.scoreText);
		this.handDeck = new CardDeck();
		this.handDeck.discardOff = new Point(144, 0);
		this.handDeck.x = 1000;
		this.handDeck.y = 160;
		
		this.lineHand = new Hand();
		
		this.lineDeck = new CardDeck();
		this.lineDeck.discardOff = new Point(144, 0);
		this.lineDeck.x = 20;
		this.lineDeck.y = 160;
		this.hand = new Hand();
		
		this.addChild(this.bg);
		this.addChild(this.handDeck);
		this.addChild(this.lineDeck);
		
		if (type == "smuggler")
		{
			this.eventDeck = new CardDeck();
			this.eventDeck.discardOff = new Point(-166, 0);
			
			this.limitDeck = new CardDeck();
			this.limitDeck.discardOff = new Point(166, 0);
			
			this.eventDeck.rotation = -Math.PI / 2;
			this.limitDeck.rotation = Math.PI / 2;
			
			this.eventDeck.x = 20;
			this.eventDeck.y = 146;
			this.eventDeck.mpx = -1;
			
			this.limitDeck.x = 1260;
			this.limitDeck.y = 20;
			this.limitDeck.mpx = -1;
			
			this.addChild(this.eventDeck);
			this.addChild(this.limitDeck);
		}
		
		this.addChild(this.lineHand);
		this.addChild(this.hand);
		
		this.lineHand.x = 300;
		this.lineHand.y = 160;
		
		this.hand.x = 550;
		this.hand.y = 160;

		
		if(this.eventDeck != null)
			this.eventDeck.interactive = false;
		if (this.limitDeck != null)
			this.limitDeck.interactive = false;
		this.lineHand.interactive = true;
		this.hand.interactive = true;
	}
	
	public function prepare(isEnemy:Bool):Void
	{
		trace("Enemy " + isEnemy + " " + this.type);
		this.hand.isEnemy = isEnemy; 
		this.lineHand.isEnemy = isEnemy;
		this.hand.prepare();
		this.lineHand.prepare();
		this.lineDeck.isEnemy = isEnemy;
		this.handDeck.isEnemy = isEnemy;
		if (isEnemy && this.type == "smuggler")
		{
			this.limitDeck.y = 380;
			this.eventDeck.y = 360 + 140;
			
		}
		else if( this.type == "smuggler")
		{
			this.limitDeck.y = 20;
			this.eventDeck.y = 146;
			this.scoreText.y = 50;
		}
	}
	
}